/*

WinMenu for use in StarDock's WindowBlinds
Copyright (C) 2000 Shane Lardinois (lardino@ibm.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <windows.h>
#include <wingdi.h>
#include <stdio.h>
#include <assert.h>
#include <time.h>

// Import and export without a definition file
#define DllImport    __declspec( dllimport )
#define DllExport    extern "C" __declspec( dllexport )
//#define DllExport    __declspec( dllexport )
//#define DllExport

// Two typedefs of the functions that WB exports
typedef LPSTR (CALLBACK* GETNAME) (void);
typedef void (CALLBACK* SETFUNCTION) (int, int);
typedef int  (CALLBACK* GETNUMBER) (void);
typedef int  (CALLBACK* GETBUTTON) (int);

GETNAME GetUIS;
GETNAME GetWBDIR;

// Get the number of buttons
GETNUMBER GetButtonCount;

// Set the information from a particular button
SETFUNCTION SetButtonAlpha;
SETFUNCTION SetButtonX;
SETFUNCTION SetButtonY;
SETFUNCTION SetButtonAlign;
SETFUNCTION SetButtonVisibility;
SETFUNCTION SetButtonWidth;
SETFUNCTION SetButtonHeight;
SETFUNCTION SetButtonAction;

// Get the information from a particular button
GETBUTTON GetButtonAlpha;
GETBUTTON GetButtonX;
GETBUTTON GetButtonY;
GETBUTTON GetButtonAlign;
GETBUTTON GetButtonVisibility;
GETBUTTON GetButtonWidth;
GETBUTTON GetButtonHeight;
GETBUTTON GetButtonAction;

// Instance information for DLL

DllExport BOOL WBRelease (HWND hWnd, int x, int y, int state);
DllExport BOOL WBPress (HWND hWnd, int x, int y, int state);
DllExport BOOL WBQuery (HWND hWnd);
DllExport BOOL WBDraw (HWND hWnd, HDC DC, RECT* r, int state, BOOL active);

// Entry point into our function
BOOL APIENTRY DllMain(HANDLE, DWORD, LPVOID);

// My junk
HANDLE outFile;

// Instance the menu button
static HANDLE  mHInstance;
static HBITMAP mMenuButton;
static BITMAP  mMenuButtonData;

static char *strNames[] = { "Configure", "About" };
static char *keyNames[] = { "Software", "WinMenu", "WindowBlindsEx", "Settings" };

// Internal functions

HBITMAP CheckProfileString(HANDLE hInstance);

BOOL CreateSubMenuItem(HWND hWnd, HMENU hWinMenu, HMENU hWinSubMenu, LPCSTR keyName);
BOOL CreateMenuFromRegistry(HWND hWnd, HMENU hWinMenu, HKEY hKey);
BOOL CreateMenuItem(HWND hWnd, HMENU hWinMenu, LPCSTR keyName, LPCSTR keyValue);

HBITMAP CreateBitmapFromIcon(HWND hWnd, HICON iIconData, int width, int height);

BOOL InsertGraphicalMenuItem(HWND hWnd, HMENU hWinMenu, LPCSTR keyValue, MENUITEMINFO *pMenuInfo);
BOOL DeleteMenuItems(HMENU hWinMenu);
BOOL ExecuteMenuItem(HMENU hWinMenu, DWORD iMenuItem);

BOOL GetInitialConfigKey(HWND hWnd, HMENU hWinMenu);
BOOL RecurseForKeys(HWND hWnd, HMENU hWinMenu, HKEY hKey);
BOOL RecurseForValues(HWND hWnd, HMENU hWinMenu, HKEY hKey);

